// ELDongleSample.cpp : AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"
#include "commctrl.h"	// ^uRg[𗘗p邽߂ɃCN[h
#include "resource.h"
#include "ELDongleSample.h"

#define MAX_LOADSTRING 100

// O[oϐ:
HINSTANCE g_hInstance;								// ݂̃C^[tFCX
TCHAR szTitle[MAX_LOADSTRING];					// ^Cg o[̃eLXg

HWND g_hDlg;

static HWND hTab;					// ^uRg[
HWND g_hTabBasic;
HWND g_hTabExtended;

INT_PTR CALLBACK BasicDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
INT_PTR CALLBACK ExtendedDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);

BOOL CALLBACK MainDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam) 
{

	TC_ITEM tc;						
	RECT	rt;						
	NMHDR *nm = (NMHDR *)lParam;	
	LPPOINT pt = (LPPOINT)&rt;		
	int     idx = 0;

	static int nCurTab;

	switch (message) {

	case WM_INITDIALOG:

		// ^uRg[gp邽߁ARRg[̏s
		InitCommonControls();

		hTab = GetDlgItem(hDlg, IDC_TAB1);

		tc.mask = TCIF_TEXT;
		tc.pszText = _T("{");
		TabCtrl_InsertItem(hTab, idx++, &tc);

		tc.mask = TCIF_TEXT;
		tc.pszText = _T("g");
		TabCtrl_InsertItem(hTab, idx++, &tc);

		g_hTabBasic = CreateDialog(g_hInstance, (LPCTSTR)IDD_BASIC, hDlg, (DLGPROC)BasicDlgProc);
		g_hTabExtended = CreateDialog(g_hInstance, (LPCTSTR)IDD_EXTENDED, hDlg, (DLGPROC)ExtendedDlgProc);

		// ^uRg[̃NCAg̈̍W擾
		GetClientRect(hTab, &rt);
		TabCtrl_AdjustRect(hTab, FALSE, &rt);

		// eEBhEhDlgȂ̂Ń^ũ}bvKv
		MapWindowPoints(hTab, hDlg, pt, 2);

		// Basic^ũEBhËʒuƃTCYύX
		MoveWindow(g_hTabBasic, rt.left, rt.top,
			rt.right - rt.left, rt.bottom - rt.top, FALSE);

		// Extended^ũEBhËʒuƃTCYύX
		MoveWindow(g_hTabExtended, rt.left, rt.top,
			rt.right - rt.left, rt.bottom - rt.top, FALSE);

		// ftHgBasic\
		TabCtrl_SetCurSel(hTab, 0);
		ShowWindow(g_hTabBasic, SW_SHOW);

		nCurTab = 0;

		return TRUE;

		// ʒmbZ[W
	case WM_NOTIFY:

		// ^uRg[̑IĂ^uύXꂽƂʒm
		switch (nm->code) {
		case TCN_SELCHANGE:
			if (nm->hwndFrom == hTab) 
			{
				nCurTab = TabCtrl_GetCurSel(hTab);

				switch (TabCtrl_GetCurSel(hTab)) 
				{

					// Basic^u
				case 0:
					// Basic^u֐؂ւ
					ShowWindow(g_hTabBasic, SW_SHOW);	// \
					ShowWindow(g_hTabExtended, SW_HIDE);// \
					break;

					// Extended^u
				case 1:
					// Extended^u֐؂ւ
					ShowWindow(g_hTabBasic, SW_HIDE);	// \
					ShowWindow(g_hTabExtended, SW_SHOW);	// \
					break;
				}
			}
			break;
		}

		return TRUE;

	case WM_COMMAND:

		switch (LOWORD(wParam))
		{
		case IDOK:
		case IDCANCEL:
			DestroyWindow(hDlg);
			PostQuitMessage(0);
			break;
		}
		break;

	default:
		return FALSE;
	}

	return TRUE;

}

int APIENTRY _tWinMain(_In_ HINSTANCE hInstance,
                     _In_opt_ HINSTANCE hPrevInstance,
                     _In_ LPTSTR    lpCmdLine,
                     _In_ int       nCmdShow)
{
	UNREFERENCED_PARAMETER(hPrevInstance);
	UNREFERENCED_PARAMETER(lpCmdLine);

 	// TODO: ɃR[h}ĂB
	MSG msg;

	// O[oĂ܂B
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);

	//QdN̖h~
	HANDLE hMutex = ::CreateMutex(NULL, TRUE, L"ELDongleSample");
	if (GetLastError() == ERROR_ALREADY_EXISTS)
	{
		CloseHandle(hMutex);
		MessageBox(NULL, _T("ʂ̃CX^XNł"), szTitle, MB_OK | MB_ICONEXCLAMATION);
		return FALSE;
	}

	g_hInstance = hInstance;

	HWND hDlg = CreateDialog(hInstance, MAKEINTRESOURCE(IDD_MAIN), NULL, (DLGPROC)MainDlgProc);

	ShowWindow(hDlg, SW_SHOW);

	while (GetMessage(&msg, NULL, 0, 0))
	{
		if (hDlg == 0 || !IsDialogMessage(hDlg, &msg))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}


	return (int)msg.wParam;

}
